-- soilworkImplementLoweringFix 
-- For soilwork implements to simulate them being pulled into the ground rather than falling into the ground.

-- by modelleicher (https://www.youtube.com/modelleicher) 
-- Version 1.0 -- 22.12.2020 initial implementation for Eberhardt Gazelle 750/11 

soilworkImplementLoweringFix = {};

function soilworkImplementLoweringFix.prerequisitesPresent(specializations)
    return true;
end;

function soilworkImplementLoweringFix.registerEventListeners(vehicleType)
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", soilworkImplementLoweringFix);
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", soilworkImplementLoweringFix);
	SpecializationUtil.registerEventListener(vehicleType, "onPostLoad", soilworkImplementLoweringFix);
	SpecializationUtil.registerEventListener(vehicleType, "onSetLowered", soilworkImplementLoweringFix);
end;


function soilworkImplementLoweringFix:onLoad(savegame)
	
	self.spec_soilworkImplementLoweringFix = {};
	local spec = self.spec_soilworkImplementLoweringFix;
	
	
	local animationName = getXMLString(self.xmlFile, "vehicle.soilworkImplementLoweringFix#animationName");
	if animationName ~= "" and animationName ~= nil then
		spec.animationName = animationName;
	else
		spec = nil;
	end;

end;
function soilworkImplementLoweringFix:onPostLoad(savegame)
	local spec = self.spec_soilworkImplementLoweringFix;
	if spec ~= nil then
		self:playAnimation(spec.animationName, 1, self:getAnimationTime(spec.animationName), true);
	end;
end;

function soilworkImplementLoweringFix:onSetLowered(lowered)
	local spec = self.spec_soilworkImplementLoweringFix;
	if spec ~= nil and not lowered then
		self:stopAnimation(spec.animationName, true);
		self:playAnimation(spec.animationName, 0.3, self:getAnimationTime(spec.animationName), true);
	end;
end;

function soilworkImplementLoweringFix:onUpdate(dt) 
	local spec = self.spec_soilworkImplementLoweringFix;
	if spec ~= nil then
		local lastSpeed = self:getLastSpeed(true);
		local enabled = self:getDoGroundManipulation() and self:getIsOnField();
		
		if enabled and self:getIsLowered() and self:getAnimationTime(spec.animationName) > 0 then
			self:playAnimation(spec.animationName, -(0.05 * lastSpeed), nil, true);
		end;
	end;
end;
